#include <winsock2.h>
#include <stdio.h>
#include <stdlib.h>

int main()
{
  int  Sresult;
  SOCKET udpsocket;
  char buf[256];
  char buf2[300];
  SOCKADDR_IN addr;
  SOCKADDR_IN remoteAddr;
  int remoteAddrLen=sizeof(SOCKADDR_IN);


  WSADATA wsdata;
  Sresult=WSAStartup(MAKEWORD(2,0),&wsdata);

  if(Sresult!=0)
  {
    printf("Error in startWinsock, code: %d\n",Sresult);
    return 1;
  }
  else
  {
    printf("Winsock is started!\n");
  }

  //create a UDP Socket
  udpsocket=socket(AF_INET,SOCK_DGRAM,0);
  if(udpsocket==INVALID_SOCKET)
  {
    printf("Error in socket,  code: %d\n",WSAGetLastError());
    return 1;
  }
  else
  {
    printf("UDP Socket is started!\n");
  }

  addr.sin_family=AF_INET;
  addr.sin_port=htons(1234);
  addr.sin_addr.s_addr=ADDR_ANY;

  Sresult=bind(udpsocket,(SOCKADDR*)&addr,sizeof(SOCKADDR_IN));
  if(Sresult==SOCKET_ERROR)
  {
    printf("Error in bind, code: %d\n",WSAGetLastError());
    return 1;
  }
  else
  {
    printf("Socket is is attached to port 12345\n");
  }
//data exchange
  while(1)
  {
    Sresult=recvfrom(udpsocket,buf,256,0,(SOCKADDR*)&remoteAddr,&remoteAddrLen);
    if(Sresult==SOCKET_ERROR)
    {
      printf("Error in recvfrom, code: %d\n",WSAGetLastError());
      return 1;
    }
    else
    {
      printf("%d Bytes have been received!\n", Sresult);
      buf[Sresult]='\0';
    }
    printf("Received Data: %s\n",buf);

    //send back
    sprintf(buf2,"you just sent me %s",buf);
    Sresult=sendto(udpsocket,buf2,strlen(buf2),0,(SOCKADDR*)&remoteAddr,remoteAddrLen);
    if(Sresult==SOCKET_ERROR)
    {
      printf("Error sendto, code: %d\n",WSAGetLastError());
      return 1;
    }
    else
    {
      printf("%d Bytes have been  sent!\n", Sresult);
    }
  }
  return 0;
}


