#include <windows.h>
#include <winsock2.h>
#include <stdio.h>
#include <stdlib.h>

int main()
{

  SOCKET acceptSocket;
  SOCKET connectedSocket;
  SOCKADDR_IN addr;
  char buf[256];
  char buf2[300];
  WSADATA wsaData;
  int SResult;


  //Starts Winsock
  SResult=WSAStartup(MAKEWORD(2,0),&wsaData);

  if(SResult!=0)
  {
    printf("Error in starting startWinsock, code: %d\n",SResult);
    return 1;
  }
  else
  {
    printf("Winsock is started!\n");
  }

  // creat a Socket
  acceptSocket=socket(AF_INET,SOCK_STREAM,0);
  if(acceptSocket==INVALID_SOCKET)
  {
    printf("Error in socket, code: %d\n",WSAGetLastError());
    return 1;
  }
  else
  {
    printf("Socket is created!\n");
  }

  // bind socket
  memset(&addr,0,sizeof(SOCKADDR_IN));
  addr.sin_family=AF_INET;
  addr.sin_port=htons(12345);
  addr.sin_addr.s_addr=ADDR_ANY;
  SResult=bind(acceptSocket,(SOCKADDR*)&addr,sizeof(SOCKADDR_IN));
  if(SResult==SOCKET_ERROR)
  {
    printf("Error in  bind,  code: %d\n",WSAGetLastError());
    return 1;
  }
  else
  {
    printf("The Socket  is attached to port 12345 \n");
  }

  // Listen Mode
  SResult=listen(acceptSocket,10);
  if(SResult==SOCKET_ERROR)
  {
    printf("Error in listen, code: %d\n",WSAGetLastError());
    return 1;
  }
  else
  {
    printf("acceptSocket is in listen Mode....\n");
  }

  // Accept Connections
  connectedSocket=accept(acceptSocket,NULL,NULL);
  if(connectedSocket==INVALID_SOCKET)
  {
    printf("Error in accept, code: %d\n",WSAGetLastError());
    return 1;
  }
  else
  {
    printf("New Connection is accepted!\n");
  }

  // Exchange Data
  while(SResult!=SOCKET_ERROR)
  {

    SResult=recv(connectedSocket,buf,256,0);
    if(SResult==0)
    {
      printf(" Connection Closed.\n");
      break;
    }
    if(SResult==SOCKET_ERROR)
    {
      printf("Error in recv, code: %d\n",WSAGetLastError());
      break;
    }
   buf[SResult]='\0';

    printf("Client has sent: %s\n",buf);

    sprintf(buf2,"you have sent me %s",buf);
  SResult=send(connectedSocket,buf2,strlen(buf2),0);
  }
  closesocket(acceptSocket);
  closesocket(connectedSocket);
  WSACleanup();
  return 0;
}



